<?php

// Ресайзер изображений с сохранением и выводом
// Автор _Xz_ (http://torrentpier.me/members/2-_Xz_)

define('IN_FORUM', true);
define('BB_ROOT', './');
require(BB_ROOT ."common.php");

$user->session_start();

$topic_id = (int) request_var('t', '0');
if(!$topic_id) bb_die('NO TOPIC_ID!!!');

if(!$row = CACHE('bb_cache')->get("lenta-$topic_id"))
{
    $row = DB()->fetch_row("SELECT pt.post_text
		FROM ". BB_BT_TORRENTS ." tr
			LEFT JOIN ". BB_TOPICS ." t ON(tr.topic_id = t.topic_id)
			LEFT JOIN ". BB_POSTS_TEXT ." pt ON(pt.post_id = tr.post_id)
		WHERE t.topic_id  = $topic_id");
    CACHE('bb_cache')->set("lenta-$topic_id", $row, 300);
}

if(!$row) bb_die('NO TOPIC!!!');

preg_match_all('/\[poster\](.*?)\[\/poster\]/i', $row['post_text'], $poster, PREG_SET_ORDER);
preg_match_all('/\[img=right\](.*?)\[\/img\]/i', $row['post_text'], $poster2, PREG_SET_ORDER);
preg_match_all('/\[img=left\](.*?)\[\/img\]/i', $row['post_text'], $poster3, PREG_SET_ORDER);
preg_match_all('/\[img\](.*?)\[\/img\]/i', $row['post_text'], $poster4, PREG_SET_ORDER);

$url = '';
if (@$poster[0][1])
{
	$url = $poster[0][1];
}
elseif (@$poster2[0][1])
{
	$url = $poster2[0][1];
}
elseif (@$poster3[0][1])
{
	$url = $poster3[0][1];
}
elseif (@$poster4[0][1])
{
    $url = $poster4[0][1];
}

$filetype = substr(strrchr($url, '.'), 1);
$filename = substr($url, strrpos($url, '/'));
$no_poster = IMAGES_DIR . 'thumb_no_poster.png'; //путь до no-poster.png
$folder = INT_DATA_DIR . 'thumbnails/'; //путь до папки с постерами
$thumb_file = $folder . $filename;

// Проверяем на наличие
if (@fopen($thumb_file, "r"))
{
	switch ($filetype)
	{
		case 'jpg':
		case 'jpeg':
			header('Content-type: image/jpeg');
			header('Content-Disposition: filename='. $filename);
		  break;
		case 'png':
			header('Content-type: image/png');
			header('Content-Disposition: filename='. $filename);
		  break;
		case 'gif':
			header('Content-type: image/gif');
			header('Content-Disposition: filename='. $filename);
		  break;
	}
	readfile($thumb_file);
	exit;
}
else
{
    //Пробуем открыть файл для чтения
	if (@fopen($url, "r"))
	{
        // Узнаём размеры
		@list($poster_width, $poster_height) = getimagesize($url);

	    if(!$poster_width || !$poster_height) //Проверяем на изображение
	    {
	    	header('Content-type: image/png');
	    	header('Content-Disposition: filename=thumb_no_poster.png');
			readfile($no_poster);
	    }
	    else
	    {
		    @list($poster_width, $poster_height) = getimagesize($url);

		    if(!$poster_width && !$poster_height) //Проверяем на наличие
		    {
		    	header('Content-type: image/png');
		    	header('Content-Disposition: filename=thumb_no_poster.png');
				readfile($no_poster);
		    }


		    switch ($filetype)
		    {
		    	case 'jpg':
				case 'jpeg':
					$poster = ImageCreateFromJPEG($url);
				  break;
				case 'png':
					$poster = ImageCreateFromPNG($url);
				  break;
				case 'gif':
					$poster = ImageCreateFromGIF($url);
				  break;
		    }

		    $max_width = 110; //Уменьшение по ширине


			$thumb_width = $max_width;
			$thumb_height = 135;

		    if(($poster_width > $max_width))
		    {
		    	$thumb = imagecreatetruecolor($thumb_width, $thumb_height);

                //Прозрачность миниатюры в PNG, если имеется
			    imagealphablending($thumb, false);
				imagesavealpha($thumb, true);

				imagecopyresampled($thumb, $poster, 0, 0, 0, 0, $thumb_width, $thumb_height, $poster_width, $poster_height);
		    }
		    else
		    {
		    	 $thumb = $poster;
		    }

            //Создаём миниатюру
		    switch($filetype)
		    {
		    	case "jpg":
		    	case "jpeg":
					header('Content-type: image/jpeg');
					header('Content-Disposition: filename='. $filename);
			    	ImageJPEG($thumb, $thumb_file, 100);
					break;
				case "png":
				    header("Content-type: image/png");
				    header('Content-Disposition: filename='. $filename);
					ImagePNG($thumb, $thumb_file);
					break;
				case "gif":
				    header("Content-type: image/gif");
				    header('Content-Disposition: filename='. $filename);
					ImageGIF($thumb, $thumb_file);
					break;
		    }
            //Закрываем
		    imagedestroy($thumb);
		    imagedestroy($poster);
		    //Читаем
		    readfile($thumb_file);
		    exit;
	    }
	}
	else
	{
		header('Content-type: image/png');
	   	header('Content-Disposition: filename=thumb_no_poster.png');
		readfile($no_poster);
	}
}
?>